#!/usr/bin/perl
#########################################################################################################
#
#       Cross-Desktop: A personal content-management-system
#
#       Particular file: setup.cgi
#
#       This program with all its parts is copyright protected.
#       The program as a whole and parts of it, like this file,is NOT free software.
#       You may not redistribute or modifiy this software
#       without prior written approval of Cross Development GbR.
#
#       Copyright 2003-2004, Cross Development, Germany
#       http://www.cross-desktop.com/
#       http://www.cross-development.com/
#
#       Contact: info@cross-desktop.com
#
#########################################################################################################
use strict;
use CGI qw(:standard);

my $firstTime = (param('firstTime')||"");
my $secure_path = (param('secure_path')||"");
my $config_path = "";
my $webdrive_path = "";#(param('webdrive_path')||"");
my $URL = (param('URL')||"");
my $dir_URL = (param('dir_URL')||"");
my $img_URL = (param('img_URL')||"");
my $img_path = "";#(param('img_path')||"");
my $html_URL = (param('html_URL')||"");
my $html_path = "";#(param('html_path')||"");
my $perl_path = (param('perl_path')||"/usr/bin/perl");
my $zip_path = (param('zip_path')||"/usr/bin/zip");
my $install_zip=(param('install_zip')||"");
my $unzip_path = (param('unzip_path')||"/usr/bin/unzip");
my $install_unzip=(param('install_unzip')||"");
my $redirect = (param('redirect')||"");
my $timeout = (param('timeout')||"3h");
my $quota = (param('quota')||"10MB");
my $basename = (param('basename')||"");
my $password = (param('password')||"");
my $retype = (param('retype')||"");
my $username=param('username')||"";
my $password_file=param('password_file')||"";
my $htaccess_password=param('htaccess_password')||"";
my $defaultUser="";
my $error ="";
my @cgifiles=("addBookmark.cgi", "addressbook.cgi", "addressbookFrame.cgi", "addresses.cgi", "blank.cgi", "changeChmod.cgi", "checkMail.cgi", "chmod.cgi", "chmodMoreFiles.cgi", "close.cgi", "configs.cgi", "contact.cgi", "controlMailSending.cgi", "crossDesktop.cgi", "crossDesktop_common.pm", "downloadAddresses.cgi", "download.cgi", "downloadCookies.cgi", "downloadform.cgi", "downloadProcess.cgi", "downloadURL.cgi", "fileListing.cgi", "filter.cgi", "filterOverview.cgi", "functions.pm", "helpcredits.cgi", "icontray.cgi", "importAddresses.cgi", "kernel.cgi", "login.cgi", "mailAccounts.cgi", "mailAddresses.cgi", "mailAddressesFrame.cgi", "mailAddressesTop.cgi", "mailfilter.pl", "mailGeneral.cgi", "mailMenu.cgi", "mailPref.cgi", "menu.cgi", "message.cgi", "modifyBookmark.cgi", "modify.cgi", "noValidUrl.cgi", "options.cgi", "POP3Client.pm", "preferences.cgi", "result.cgi", "rule.cgi", "saveAs.cgi", "saveSize.cgi", "search.cgi", "searchform.cgi", "Sender.pm", "sendMail.cgi", "sendMailFrame.cgi", "show.cgi", "showMail.cgi", "showMailProcess.cgi", "status.cgi", "testAccount.cgi", "upload.cgi", "weiterleiten.cgi");
#Files which are stored in the cgi Directory but are no cgi-files
my @notReallyCgiFiles=("fileDownload.pl", "content-types.config", "menu.config");
my @files=("addressbook.html", "addresses.html", "addresses.js", "anzeige.html", "anzeige.js", "avnch4.pdf", "blank.html", "bookmark.html", "bookmark.js", "bottom.html", "chmod.html", "contact.html", "dhtml.js", "download.js", "downloadURL.html", "error.html", "fileListing.js", "filter.html", "filterOverview.html", "helpcredits.html", "helpfunctions.js", "help.html", "icontray.html", "importAddresses.html", "login.html", "logo.html", "mailaccount.html", "mailAddressesTop.html", "mailGeneral.html", "mailMenu.html", "mailPref.html", "mailPref.js", "menu_com.js", "menu.html", "menu.js", "menu_var.js", "modifyBookmark.html", "modify.html", "options.html", "preferences.html", "rule.html", "saveAs.html", "search.html", "sendMail.html", "showMail.html", "showMailProcess.html", "status.html", "upload.html", "winManager.js");
my @images = ("abort.gif", "attachment.gif", "back.gif", "blank.gif", "cancel.gif", 
"checked.gif", "chmodAction.gif", "chn.gif", "copy.gif", "crossDesktop.css", 
"crossDesktopLogin.css", "crossdesktoplogo.gif", "cut.gif", "Deutsch", 
"download.gif", "English", "favicon.ico", "folder.gif", "Francais", 
"fwdedit.gif", "fwd.gif", "header-hg.gif", "logo_small.gif", 
"logout.gif", "mail.gif", "m_down.gif", "menu.css", "m_left16x16.gif", 
"m_left.gif", "modify.gif", "m_right16x16.gif", "m_right.gif", "mw-blank.gif", 
"mw-joinbottom.gif", "mw-join.gif", "mw-line.gif", "mw-minusbottom.gif", 
"mw-minus.gif", "mw-plusbottom.gif", "mw-plus.gif", "new-dir.gif", 
"newDocIcon.gif", "newmail.gif", "newurl.gif", "paste.gif", "prvdir.gif", 
"reloadIcon.gif", "replyall.gif", "reply.gif", "search.gif", "separator.gif", 
"trash.gif", "unchecked.gif", "unzip.gif", "upload.gif", "url-download.gif", 
"url.gif", "view.gif", "viewmail.gif", "zip.gif", "Deutsch/renamefile.gif", "Deutsch/renamefolder.gif", "Deutsch/renameIcon.gif", "Deutsch/width.css", "English/renamefile.gif", "English/renamefolder.gif", "English/renameIcon.gif", "English/width.css", "Francais/renamefile_2.gif", "Francais/renamefile.gif", "Francais/renamefolder.gif", "Francais/width.css");
my @languages=("Deutsch.lng", "English.lng", "Francais.lng");
my @Modules=("Fcntl", "LWP::UserAgent", "Time::Local", "FileHandle", "strict", "Exporter", "Mail::POP3Client", "HTTP::Cookies");

my $scriptUser=getlogin || getpwuid($<) ;
my $base_path="";
my $errorMessage="";
my $zip_checked="";
my $unzip_checked="";

srand;
if ($firstTime eq ""){
	&Error("");
}
#NEU
$base_path=`pwd`;
chomp($base_path);#Last Character: /

$URL=~s/\/setup.cgi//;
$URL=~/^(.*?:\/\/.*?\/)(.*$)/;
my $domain=$1;
my $restURL=$2;
#domain restUrl substitution of special characters;
$restURL=~s/(\+|\?|\*|\/|\\|\.|\^|\$|\(|\)|\]|\[|\}|\{)/\\$1/g;
$domain=~s/(\+|\?|\*|\/|\\|\.|\^|\$|\(|\)|\]|\[|\}|\{)/\\$1/g;
$base_path=~s/$restURL$//;
$html_path=$html_URL;
$html_path=~s/$domain/$base_path/;
$html_path=$html_path;
$config_path=$html_path;
$img_path=$img_URL;
$img_path=~s/$domain/$base_path/;
$webdrive_path=$dir_URL;
$webdrive_path=~s/$domain/$base_path/;
if ($install_zip eq "later"){
   $zip_path="Will be installed later";
   $zip_checked="checked";
}
if ($install_unzip eq "later"){
   $unzip_path="Will be installed later";
   $zip_checked="checked";
}

if ($secure_path eq "" || $config_path eq "" || $dir_URL eq "" || $img_URL eq "" || $html_URL eq "" ||$redirect eq "" ||$timeout eq "" || $password eq "" || $retype eq ""){
	$errorMessage.="Some required fields are missing.";
}if(!(-e $perl_path)){
	$errorMessage.="The specified path to perl is wrong.";
}if($install_zip ne "later" && !(-e $zip_path)){
	$errorMessage.="The specified path to zip is wrong.";
}if($install_unzip ne "later" && !(-e $unzip_path )){
	$errorMessage.="The specified path to unzip is wrong.";
}if (!($timeout=~/^\d*h*\d*m?\d*s?$/i && $timeout=~/\d+(h|m|s)/i)){
	$errorMessage.="Bad format for timeout specification";
}if (!($quota=~/^\s*\d+\s*(MB|KB|GB)\s*$/i)){
	$errorMessage.="Invalid quota form: it has to be a natural number followed by KB, MB or GB.";
}if ($password ne $retype){
	$errorMessage.="Passwords must not be different.";
}

if ($errorMessage ne ""){
	$errorMessage=~s/\./.<br>/g;
	&Error($errorMessage);
}
$secure_path=~s/\/$//;
$config_path=~s/\/$//;
$webdrive_path=~s/\/$//;
$dir_URL=~s/\/$//;
$redirect=~s/\/$//;
$img_URL=~s/\/$//;
$img_path=~s/\/$//;
$html_URL=~s/\/$//;
$html_path=~s/\/$//;

#transform quota and timeout in one int
my $quotaint=10;
$quota=~/(\d+)\s*(MB|KB|GB)/i;
if ($2 eq "KB"|| $2 eq "kb"||$2 eq "Kb"||$2 eq "kB"){$quotaint=$1;}
elsif ($2 eq "MB"|| $2 eq "mb"||$2 eq "Mb"||$2 eq "mB"){$quotaint=$1*1024;}
elsif ($2 eq "GB"|| $2 eq "gb"||$2 eq "Gb"||$2 eq "gB"){$quotaint=$1*1048576;}

my $timeoutint=0;
if ($timeout=~/(\d+)s/i){$timeoutint=$1;}
if ($timeout=~/(\d+)m/i){$timeoutint+=$1*60;}
if ($timeout=~/(\d+)h/i){$timeoutint+=$1*3600;}


#Create directories, if they do not exist, and check afterwards the existence and read/write permissions
#------------------------------------
if (!(-e $secure_path)){
	makedir($secure_path);
	if (!(-e $secure_path)){
		Error("$secure_path could not be created. Check if the user $scriptUser has the rights to create the directory. <br>It can be created manually, to  continue.");
	}
}
if (!-r $secure_path){
	Error ("The user $scriptUser is not having the right to read the secure path ($secure_path).");
}
if (!-w $secure_path){
	Error ("The user $scriptUser is not having the right to write to the secure path ($secure_path).");
}
#------------------------------------
if (!(-e $config_path)){
	makedir($config_path);
	if (!(-e $config_path)){
		Error("$config_path could not be created. Check if the user $scriptUser has the rights to create the directory. <br>It can be created manually, to  continue.");
	}
}
if (!-r $config_path){
	Error ("User $scriptUser is not having the right to read the path ($config_path).");
}
if (!-w $config_path){
	Error ("User $scriptUser is not having the right to write to the path ($config_path).");
}

#------------------------------------
if (!(-e $webdrive_path)){
	makedir($webdrive_path);
	if (!(-e $webdrive_path)){
		Error("$webdrive_path could not be created. Check if the user $scriptUser has the rights to create the directory. <br>It can be created manually, to  continue.");
	}
}

#-------------------------------------
if (!(-e $html_path)){
	makedir($html_path);
	if (!(-e $html_path)){
		Error("$html_path could not be created. Check if the user $scriptUser has the rights to create the directory. <br>It can be created manually, to  continue.");
	}
}
#if (!-r $html_path){
#	Error ("User $scriptUser has no read access to $html_path.");
#}

#--------------------------------------
if (!(-e $img_path)){
	makedir($img_path);
	if (!(-e $img_path)){
		Error("$img_path could not be created. Check if the user $scriptUser has the rights to create the directory. <br>It can be created manually, to  continue.");
	}
}
#if (!-r $image_path){
#	Error ("User $scriptUser has no read access to $image_path.");
#}




#unzip into $webdrive_path and $img_path
my $missing;
if (&missingCgiFiles ne ""){
	if (!(-e "$webdrive_path/crossDesktop.tar.gz")){
		if (!(-e "crossDesktop.tar.gz")){
			`tar xfz files.tar.gz`;
			if (!(-e "crossDesktop.tar.gz")){
				Error ("Archive crossDesktop.tar.gz could not be extracted. Check if files.tar.gz exist and check if $scriptUser has the rights to extract the file. The file can be extracted manually to continue.");
			}
		}
		`mv crossDesktop.tar.gz $webdrive_path/`;
		if (!(-e "$webdrive_path/crossDesktop.tar.gz")){
			Error("crossDesktop.tar.gz could not be moved to $webdrive_path. <br>Check if user $scriptUser has the right to move crossDesktop.tar.gz to that directory. <br>The move can be made manually to continue.");
		}
	}
	`tar xfz $webdrive_path/crossDesktop.tar.gz -C $webdrive_path`;
	if (($missing=&missingCgiFiles) ne ""){
		Error("$missing could not be extracted. <br>Check if user $scriptUser has the right to extract files to the directory $webdrive_path and check if crossDesktop.tar.gz contains the missing file.<br> The file can be extracted manually to continue.");
	}
}

if (&missingHtmlFiles ne ""){
	if (!(-e "$html_path/html.tar.gz")){
		if (!(-e "html.tar.gz")){
			`tar xfz files.tar.gz`;
			if (!(-e "html.tar.gz")){
				Error ("Archive html.tar.gz could not be extracted. Check if files.tar.gz exist and check if $scriptUser has the rights to extract the file. The file can be extracted manually to continue.");
			}
		}
		`mv html.tar.gz $html_path/`;
		if (!(-e "$html_path/html.tar.gz")){
			Error("html.tar.gz could not be moved to $html_path. <br>Check if user $scriptUser has the right to move html.tar.gz to that directory. <br>The move can be made manually to continue.");
		}
	}
	`tar xfz $html_path/html.tar.gz -C $html_path`;
	if (($missing=&missingHtmlFiles) ne ""){
		Error("$missing could not be extracted. <br>Check if user $scriptUser has the right to extract files to the directory $html_path and check if html.tar.gz contains the missing file.<br> The file can be extracted manually to continue.");
	}
}

if (&missingLanguages ne ""){
	if (!(-e "$config_path/languages.tar.gz")){
			if (!(-e "languages.tar.gz")){
				`tar xfz files.tar.gz`;
				if (!(-e "languages.tar.gz")){
					Error ("Archive languages.tar.gz could not be extracted. Check if files.tar.gz exist and check if $scriptUser has the rights to extract the file. The file can be extracted manually to continue.");
				}
			}
			`mv languages.tar.gz $config_path/`;
			if (!(-e "$config_path/languages.tar.gz")){
				Error("languages.tar.gz could not be moved. <br>Check if user $scriptUser has the right to move languages.tar.gz to the directory $config_path. <br>The move can be made manually to continue.");
			}
	}
	`tar xfz $config_path/languages.tar.gz -C $config_path`;
	if (($missing=&missingLanguages) ne ""){
		Error("$missing could not be extracted. <br>Check if user $scriptUser has the right to extract files to the directory $config_path and check if languages.tar.gz contains the missing file.<br> The file can be extracted manually to continue.");
	}

}


if (&missingImages ne ""){
	if (!(-e "$img_path/images.tar.gz")){
			if (!(-e "images.tar.gz")){
				`tar xfz files.tar.gz`;
				if (!(-e "images.tar.gz")){
					Error ("Archive images.tar.gz could not be extracted. Check if files.tar.gz exist and check if $scriptUser has the rights to extract the file. The file can be extracted manually to continue.");
				}
			}
			`mv images.tar.gz $img_path/`;
			if (!(-e "$img_path/images.tar.gz")){
				Error("images.tar.gz could not be moved. <br>Check if user $scriptUser has the right to move images.tar.gz to that directory. <br>The move can be made manually to continue.");
			}
	}
	`tar xfz $img_path/images.tar.gz -C $img_path`;
	if (($missing=&missingImages) ne ""){
		Error("$missing could not be extracted. <br>Check if user $scriptUser has the right to extract files to the directory $img_path and check if images.tar.gz contains the missing file.<br> The file can be extracted manually to continue.");
	}

}

#Make content directories
mkdir "$secure_path/files", 0755;
mkdir "$secure_path/files/mail", 0755;


#Create Password File
my @chars = ( "A" .. "Z", "a" .. "z", 0 .. 9);
my $salt = join ("",@chars[ map { rand @chars } (1,2) ]);
open (PASSWORD,">$secure_path/pass") || Error("Konnte nicht \&ouml;ffnen: $secure_path/$defaultUser/pass for writing. $!");
print PASSWORD (crypt($password,$salt));
close PASSWORD;

#Change Mode of every cgi file to 755
my $element;
my $cnt;
my $failed="";
foreach $element(@cgifiles){
	$cnt=chmod 0755, "$webdrive_path/$element";
	if ($cnt!=1){
		$failed.="$element, ";
	}
}
$failed=~s/, $//;
my $warning="";
if ($failed ne ""){
 	$warning= "WARNUNG: $failed could not set to mode executable . <br>Try to submit the command yourself (chmod ugo+x file.cgi). Otherwise, the script cannot be executed.";
}

#Change first line of every script to #!perl_path
my $file;
my $content;
if ($perl_path ne "/usr/bin/perl"){
	foreach $file(@cgifiles){
		open(FILE, "$webdrive_path/$file") || Error("Could not open: $webdrive_path/$file");
		$content=join('',<FILE>);
		$content=~s/\#!\/usr\/bin\/perl/\#!$perl_path/;
		close FILE;
		open(FILE, ">$webdrive_path/$file") || Error("Could not open: $webdrive_path/$file");
		print FILE $content;
		close FILE;
	}
}

#Create index.html for webdrive_path img_path and html_path
if (!(-e "$webdrive_path/index.html")){
	open (INDEX, ">$webdrive_path/index.html")||Error("Could not create: $webdrive_path/index.html. <br> Check if the user $scriptUser has the right to create files in that directory. The file can be created manually to continue.");
	print INDEX '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="REFRESH" content="0;URL=login.cgi">
<title>Cross-Desktop - Installation</title>
</head>

<body>
</body>
</html>';
close INDEX;
}

if (!(-e "$img_path/index.html")){
	open (INDEX, ">$img_path/index.html")||Error("Could not create: $img_path/index.html. <br> Check if the user $scriptUser has the right to create files in that directory. The file can be created manually to continue.");
	print INDEX '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="REFRESH" content="0;URL='.$dir_URL.'/login.cgi">
<title>Cross-Desktop - Installation</title>
</head>

<body>
</body>
</html>';
close INDEX;
}

if (!(-e "$html_path/index.html")){
	open (INDEX, ">$html_path/index.html")||Error("Could not create: $html_path/index.html. <br> Check if the user $scriptUser has the right to create files in that directory. The file can be created manually to continue.");
	print INDEX '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="REFRESH" content="0;URL='.$dir_URL.'/login.cgi">
<title>Cross-Desktop - Installation</title>
</head>

<body>
</body>
</html>';
close INDEX;
}


#Write the Config file
open (CONFIGFILE,">$webdrive_path/crossDesktop.config")|| Error("Could not open for write access: $webdrive_path/crossDesktop.config.");
print CONFIGFILE "\# Just enter directorynames without \"/\" at the end
secure_path $secure_path
dir_URL $dir_URL
img_URL $img_URL
html_URL $html_URL
html_path $html_path
zip_path $zip_path
unzip_path $unzip_path
redirect $redirect
session_timeout $timeoutint
files_path $secure_path/files
default_quota $quotaint
showedBase $basename";
close CONFIGFILE;

#Create the htaccess file
if ($username ne ""|| $password_file ne ""){
	if ($password_file eq ""){$password_file="$secure_path/.passfile";}
	open (HTACCESS, ">$secure_path/.htaccess")|| Error ("Could not open for write access: $secure_path/.htaccess.");
	print HTACCESS "AuthUserFile $password_file
AuthGroupFile /dev/null
AuthName \"Private Area\"
AuthType Basic
<Limit GET POST>
require valid-user
</Limit>";
	close HTACCESS;

	if (!(-e "$password_file")){
		open (PASS, ">$password_file");
		my $crypted=&Crypt_Password($htaccess_password);
		print PASS "$username:$crypted";
		close PASS;
		
		#`htpasswd -bc $password_file $username $htaccess_password`;
		if (!(-e "$password_file")){Error ("Could not create: $password_file. <br> The file can be created manually (use htpasswd) to continue.");}
	}
		
}

#delete *.tar.gz
unlink "$webdrive_path/crossDesktop.tar.gz", "$img_path/images.tar.gz", "$html_path/html.tar.gz", "$config_path/languages.tar.gz", "files.tar.gz";

#return HTML Page
my $zip_information="";
if ($install_zip eq "later"|| $install_unzip eq "later"){
  $zip_information="Before using Cross-Desktop, please provide the path to zip and unzip in the crossDesktop.config file. Otherwise, the zip functions will not be available to users.<br><br>";
}

my $missingModules="";
foreach my $module (@Modules){
	eval("use $module");
	if ($@) {
    		$missingModules.="$module, ";
	}
}
if ($missingModules ne ""){
	$missingModules=~s/, $//;
	$warning.="<br>Some Modules are missing: $missingModules.<br> Install these modules in order to use Cross-Desktop without functional limitations!!<br>";
}


print header();

print <<EOP;
<html><head><title>The installation was successful</title>
<style type="text/css">
<!--	BODY {
	FONT-SIZE: 11px; FONT-FAMILY: verdana, helvetica, sans-serif; BACKGROUND-COLOR: #f9f9f8; margin-right:5px;
  		margin-left:5px;
		margin-top:5px;
  
}
TD {
	FONT-SIZE: 11px; COLOR: #000000; FONT-FAMILY: verdana, helvetica, sans-serif 
}
INPUT {
	FONT-SIZE: 11px; FONT-FAMILY: verdana, helvetica, sans-serif
}
TABLE{
	width: 100%; border:0px;
}
.row2 {
	/*BACKGROUND-COLOR: #FFFFFF*/
	font-weight:bold;
}
.row1 {
	/*BACKGROUND-COLOR: #EEEEEE*/
}
.head1 {
	FONT-WEIGHT: bold; 
	FONT-SIZE: 20px; 
	COLOR:#FFFFFF;
	TEXT-ALIGN: center;
}
.head1Table{
	BACKGROUND-COLOR: #3980f4;
	border-width:1px 1px 1px 1px; 
	border-style:solid; 
	border-color:#00138c;
}
.greyBox{
	border-width:1px; border-style:solid; border-color:#00138c;
	background-color: #EDEBE6
}
.prob {color:#990000;
	font-size:13px;
	font-weight:bold;
}
.haveFun{
	color:#000099;
	font-size:18px;
	font-weight:bold;
}
</style>

</head>

<BODY>
<table cellpadding=3 cellspacing=1>
<tr><td>
<table class="head1Table">
	<tr><td class="head1" >The installation was successful</td></tr>
</table>
</td></tr>
<tr><td>
<table class="greyBox" >
<tr class='col2'><td colspan=3>&nbsp;&nbsp;</td></tr>
<tr><td class='prob' colspan=3 align="center">$warning</td></tr>
<tr class='row2'><td colspan=3>Your setup</td></tr>

<tr class='row1'><td width=2%>&nbsp;</td><td width="25%">Secure path* </td><td> $secure_path</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Cross-Desktop path </td><td> $webdrive_path</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Cross-Desktop URL* </td><td> $dir_URL</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>HTML path* </td><td> $html_path</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>HTML URL* </td><td> $html_URL</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Image path </td><td> $img_path</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Image URL* </td><td> $img_URL</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Perl path </td><td> $perl_path</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Zip path* </td><td> $zip_path</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Unzip  path* </td><td> $unzip_path</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Redirect to* </td><td> $redirect</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Session timeout* </td><td> $timeout (is $timeoutint seconds)</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Quota* </td><td> $quotaint kb, $quota </td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Basename* </td><td> $basename</td></tr>

<tr><td colspan=3><center>You can change any parameter marked * in the file $webdrive_path/crossDesktop.config (Be careful! <i>Never</i> end path names with a trailing "/" ).<br>

Any other information has been used for the installation process only.
<br><br>$zip_information</td></tr>

<tr><td colspan=3 class="prob"><center>For savety reasons the file setup.cgi should be removed. With that move, changes to the configuration and passwords by third parties are avoided.<br><br></td></tr>

<tr><td colspan=3 ><center>You can start Cross-Desktop with the link <a href="$html_URL/">$html_URL/</a> if the file index.html works or use <a href="$dir_URL/login.cgi">$dir_URL/login.cgi</a>.<br>

The initial username ist $defaultUser. The password has been chosen by you. The preferences of the user $defaultUser can be changed in the administration dialog of Cross-Desktop at any time later. The administration dialog is part of the application menu.</td></tr>
<tr><td colspan=3>&nbsp;&nbsp;</td></tr>
<tr><td colspan=3 class='haveFun'><center>Enjoy Cross-Desktop.</center></td></tr>
</table>
</td></tr>
</table>
</body>
</html>

EOP



sub Error{
	$error=shift @_;
	$error="<tr><td colspan=4 align=center class='prob'>$error</td></tr>";
	print header();
	
	print <<EOP;
	<html><head><title>Cross-Desktop Installation</title>
	<style type="text/css">
	<!--
	BODY {
	FONT-SIZE: 11px; FONT-FAMILY: verdana, helvetica, sans-serif; BACKGROUND-COLOR: #f9f9f8; margin-right:5px;
  		margin-left:5px;
		margin-top:5px;
  
}
TD {
	FONT-SIZE: 11px; COLOR: #000000; FONT-FAMILY: verdana, helvetica, sans-serif 
}
INPUT {
	FONT-SIZE: 11px; FONT-FAMILY: verdana, helvetica, sans-serif
}
TABLE{
	width: 100%; border:0px;
}
.row2 {
	/*BACKGROUND-COLOR: #FFFFFF*/
	font-weight:bold;
}
.row1 {
	/*BACKGROUND-COLOR: #EEEEEE*/
}
.head1 {
	FONT-WEIGHT: bold; 
	FONT-SIZE: 20px; 
	COLOR:#FFFFFF;
	TEXT-ALIGN: center;
}
.head1Table{
	BACKGROUND-COLOR: #3980f4;
	border-width:1px 1px 1px 1px; 
	border-style:solid; 
	border-color:#00138c;
}
.greyBox{
	border-width:1px; border-style:solid; border-color:#00138c;
	background-color: #EDEBE6
}
.prob {color:#990000;
	font-size:13px;
	font-weight:bold;
}
	//-->
	</style>
	
	</head>
	
	<BODY>
	<form name="Configform" ENCTYPE='multipart/form-data' method='Post' action="setup.cgi">
	<table width='100%' cellpadding=3 cellspacing=1>
	<tr><td>
	<table class="head1Table">
		<tr><td class="head1" >Cross-Desktop Installation </td></tr>
	</table>
	</td></tr>
	<tr><td>
	<table class="greyBox">

	
	$error

	<tr class="row2"><td width=1%>&nbsp;</td><td width=15%>Secure Path</td><td colspan=2><input type=text name="secure_path" value="$secure_path" size=70 ></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	Path to store passwords and session data for a particular user. The directory will be created by the installation process if not already existing. If to be created the user $scriptUser running setup.cgi has to have write access to that directory. In this directory Cross-Desktop will later create a directory for any created user named by the user name. The user specific data will be stored in this directory. The directory will be created automatically by setup.cgi if the script is write enabled to do this.
	<br>Example: 
	<br>Concept 1: /home/www/website/html/xddata/store
	<br>Concept 2: /home/xddata/store
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
	
	<tr class="row2"><td>&nbsp;</td><td>URL</td><td colspan=2><input type=text name="dir_URL" value="$dir_URL" size=70></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	URL to access the program files of Cross-Desktop. The webserver must be configured to execute cgi-scripts in this directory. The directory will be created automatically by setup.cgi if the script has write access to do this.
	<br>Example: http://www.website.de/cgi-bin/crossDesktop
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
		
	<tr class="row2"><td>&nbsp;</td><td>HTML URL</td><td colspan=2><input type=text name="html_URL" value="$html_URL" size=70></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	URL to access the Html and Javascript files of Cross-Desktop. The directory will be created automatically by setup.cgi if the script has write access to do this.
	<br>Example: http://www.website.de/crossDesktop/html
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
		
	<tr class="row2"><td>&nbsp;</td><td>Image URL</td><td colspan=2><input type=text name="img_URL" value="$img_URL" size=70></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	URL to access the image files of Cross-Desktop. The directory will be created automatically by setup.cgi if the script has write access to do this.
	<br>Example: http://www.website.de/crossDesktop/images
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
	
	<tr class="row2"><td>&nbsp;</td><td>Perl path</td><td colspan=2><input type=text name="perl_path" value="$perl_path" size=70></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	Path where the perl installation resides. Normally, /usr/bin/perl. The webspace documentation provided by your isp may help.
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>

	<tr class="row2"><td>&nbsp;</td><td>Zip path</td><td colspan=2><input type=text name="zip_path" value="$zip_path" size=70><input type=checkbox $zip_checked name=install_zip value="later">Install zip later.</td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	Directory where to start the zip program. Normally, /usr/bin/zip. Some systems require to additionally install zip. Setup.cgi can consider this by the check box "Install zip later". The webspace documentation provided by your isp may help.
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>

	<tr class="row2"><td>&nbsp;</td><td>Unzip path</td><td colspan=2><input type=text name="unzip_path" value="$unzip_path" size=70><input type=checkbox  $unzip_checked name=install_unzip value="later">Install unzip later.</td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	Directory where to start the unzip program. Normally, /usr/bin/unzip. Some systems require to additionally install zip. Setup.cgi can consider this by the check box "Install zip later". The webspace documentation provided by your isp may help.
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>

	
	<tr class="row2"><td>&nbsp;</td><td>Redirect</td><td colspan=2><input type=text name="redirect" value="$redirect" size=70></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	URL to redirect the browser to after logging off Cross-Desktop.
	<br>Example: 
	<br>Homepage: http://www.website.de/
	<br>Re-Login: http://www.website.de/crossDesktop/html (Path contains index.html to redirect)
	<br>Re-Login: http://www.website.de/cgi-bin/crossDesktop/login.cgi (Direct call)
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
	
	<tr class="row2"><td>&nbsp;</td><td>Session Timeout</td><td colspan=2><input type=text name="timeout" value="$timeout"></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	Time for the runtime period of a user session. The time can be configured in the form 4h as for four hours or 3h4m30s as for three hours, four minutes, and 30 seconds. Only integer numbers are allowed for time specification.
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
	
	<tr class="row2"><td>&nbsp;</td><td>Maximum Quota</td><td colspan=2><input type=text name="quota" value="$quota"></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	Memory limit for initial user. Provide integer numbers in KB, MB or GB.
	<br>Example: 40MB.
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
	
	<tr class="row2"><td>&nbsp;</td><td>Showed basename</td><td colspan=2><input type=text name="basename" value="$basename"></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	Name to be displayed for root directory in the file listing.
	<br>Example: Root
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
	
	<tr class="row2"><td>&nbsp;</td><td>Password</td><td colspan=2><input type=password name="password"></td></tr>
	<tr class="row1"><td>&nbsp;</td><td>Retype password:</td><td colspan=2><input type=password name="retype"></td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>

	<tr class="row2" ><td>&nbsp;</td>
		<td colspan=3>Protection of the secure path (optional)</td></tr>
	<tr class="row1"><td>&nbsp;</td><td>Username:</td><td colspan=2><input type=text name="username" value="$username"></td></tr>
	<tr class="row1"><td>&nbsp;</td><td>Password:</td><td colspan=2><input type=password name="htaccess_password" ></td></tr>
	<tr class="row1"><td>&nbsp;</td><td>&nbsp;</td><td colspan=2>
	With respect to installation concept 1, this option result in the creation of a .htaccess file that will save user data in the case that user data will be stored in the root directory of the webserver. This option allows to specify dedicated access to the secure data area or enables to use an existing user list. In this case, the user list means to be system administrator users that will maintain the directory tree for this particular data area and will need web access to this data area. More information about .htaccss files can be obtained from the webserver documentation.
	</td></tr>
	<tr class="row1"><td>&nbsp;</td><td>Password file:</td><td colspan=2><input type=text name="password_file" value="$password_file" size=70></td></tr>
	<tr class="row1"><td>&nbsp;</td><td>&nbsp;</td><td colspan=2>
	(Optional, for experts!) This option allows to use a existing password file for this issue. The parameters username and password are to be left empty.
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
	</table>
	</td></td>
	<tr><td>
	<table class=greyBox>
		<tr> <td colspan=3>&nbsp;</td></tr>
		<tr align=center><td width=33% align=center ><input type="submit" name="Submit" value="OK" style="width:80px"></td>
		<td width = 33%><input type="reset" name="Clear" value="Clear" style="width:80px"></td>
		<td><input type=button value="Reset" onclick="javascript:resetValues()" style="width:80px"></td></tr>
		<tr> <td colspan=3>&nbsp;</td></tr>
	</table>
	</td></tr>
	</table>
	<input type="hidden" name="URL" value="">
	<input type="hidden" name="firstTime" value="No">

	</form>
EOP
	print '
	<SCRIPT LANGUAGE="JavaScript"><!-- Hide script
	var dir=document.URL;
	document.Configform.URL.value=dir;
	//alert(document.Configform.URL.value);
	var url="";
	if (document.Configform.URL.value ==""){
		url=window.prompt("Ihr Browser versendet die aktuelle URL nicht. Bitte geben Sie sie hier ein (Z.B. http://www.mysite.com/crossDesktop/setup.cgi). Andernfalls scheitert die Installation.","http://www.mysite.com/crossDesktop/setup.cgi");
		document.Configform.URL.value=url;
		dir=url;
	}';
if ($firstTime eq ""){
	print 'function resetValues(){
		dir=dir.replace(/\/setup\.cgi/,"");
		document.Configform.dir_URL.value=dir;
		dir=dir.replace(/\/cgi-bin.*/,"");
		document.Configform.img_URL.value=dir+"/crossDesktop/images";
		document.Configform.html_URL.value=dir+"/crossDesktop/html";
		re = /(http:\/\/[^\/]*)/;
		re.exec(dir);
		document.Configform.redirect.value=RegExp.$1;

	}
	resetValues();	';
	}
print '	// End script hiding --></SCRIPT>
</BODY>
	</HTML>';
	exit;
	
}

sub missingCgiFiles{
	my $missing="";
	my $file;
	foreach $file(@cgifiles){
		if (!(-e "$webdrive_path/$file")){
			$missing.="$file, ";	
		}
	}
	foreach $file(@notReallyCgiFiles){
		if (!(-e "$webdrive_path/$file")){
			$missing.="$file, ";	
		}
	}

	$missing=~s/,\s$//;
	return $missing;
}

sub missingHtmlFiles{
	my $missing="";
	my $file;
	foreach $file(@files){
		if (!(-e "$html_path/$file")){
			$missing.="$file, ";	
		}
	}
	$missing=~s/,\s$//;
	return $missing;
}

sub missingLanguages{
	my $missing="";
	my $file;
	foreach $file(@languages){
		if (!(-e "$config_path/$file")){
			$missing.="$file, ";	
		}
	}
	$missing=~s/,\s$//;
	return $missing;
}
	

sub missingImages{
	my $missing="";
	my $file;
	foreach $file(@images){
		if (!(-e "$img_path/$file")){
			$missing.="$file, ";	
		}
	}
	$missing=~s/,\s$//;
	return $missing;
}

sub Crypt_Password {
  my ($pwdplain) = $_[0];
  my $salt = seedchar().seedchar();;
  my $result;     
  $result = crypt($pwdplain,$salt);
  return $result;

  sub seedchar { 
    ('a'..'z','A'..'Z','0'..'9','.','/')[rand(64)];
  }
}

sub makedir{
        my $dir=shift @_;
        $dir=~s/^\///;
        my @Dirparts=split "/", $dir;
        my $growingDir="/";
        foreach $element(@Dirparts){
                $growingDir.=$element."/";
                if (!(-e $growingDir)){
                        mkdir $growingDir, 0755;
                }
        }
}
