#!/usr/bin/perl
#########################################################################################################
#
#       Cross-Desktop: A personal content-management-system
#
#       Particular file: setup.cgi
#
#       This program with all its parts is copyright protected.
#       The program as a whole and parts of it, like this file,is NOT free software.
#       You may not redistribute or modifiy this software
#       without prior written approval of Cross Development GbR.
#
#       Copyright 2003-2004, Cross Development, Germany
#       http://www.cross-desktop.com/
#       http://www.cross-development.com/
#
#       Contact: info@cross-desktop.com
#
#########################################################################################################
use strict;
use CGI qw(:standard);

my $firstTime = (param('firstTime')||"");
my $secure_path = (param('secure_path')||"");
my $config_path = "";
my $webdrive_path = "";#(param('webdrive_path')||"");
my $URL = (param('URL')||"");
my $dir_URL = (param('dir_URL')||"");
my $img_URL = (param('img_URL')||"");
my $img_path = "";#(param('img_path')||"");
my $html_URL = (param('html_URL')||"");
my $html_path = "";#(param('html_path')||"");
my $perl_path = (param('perl_path')||"/usr/bin/perl");
my $zip_path = (param('zip_path')||"/usr/bin/zip");
my $install_zip=(param('install_zip')||"");
my $unzip_path = (param('unzip_path')||"/usr/bin/unzip");
my $install_unzip=(param('install_unzip')||"");
my $redirect = (param('redirect')||"");
my $timeout = (param('timeout')||"3h");
my $quota = (param('quota')||"10MB");
my $basename = (param('basename')||"");
my $password = (param('password')||"");
my $retype = (param('retype')||"");
my $username=param('username')||"";
my $password_file=param('password_file')||"";
my $htaccess_password=param('htaccess_password')||"";
my $defaultUser="";
my $error ="";
my @cgifiles=("addBookmark.cgi", "addressbook.cgi", "addressbookFrame.cgi", "addresses.cgi", "blank.cgi", "changeChmod.cgi", "checkMail.cgi", "chmod.cgi", "chmodMoreFiles.cgi", "close.cgi", "configs.cgi", "contact.cgi", "controlMailSending.cgi", "crossDesktop.cgi", "crossDesktop_common.pm", "downloadAddresses.cgi", "download.cgi", "downloadCookies.cgi", "downloadform.cgi", "downloadProcess.cgi", "downloadURL.cgi", "fileListing.cgi", "filter.cgi", "filterOverview.cgi", "functions.pm", "helpcredits.cgi", "icontray.cgi", "importAddresses.cgi", "kernel.cgi", "login.cgi", "mailAccounts.cgi", "mailAddresses.cgi", "mailAddressesFrame.cgi", "mailAddressesTop.cgi", "mailfilter.pl", "mailGeneral.cgi", "mailMenu.cgi", "mailPref.cgi", "menu.cgi", "message.cgi", "modifyBookmark.cgi", "modify.cgi", "noValidUrl.cgi", "options.cgi", "POP3Client.pm", "preferences.cgi", "result.cgi", "rule.cgi", "saveAs.cgi", "saveSize.cgi", "search.cgi", "searchform.cgi", "Sender.pm", "sendMail.cgi", "sendMailFrame.cgi", "show.cgi", "showMail.cgi", "showMailProcess.cgi", "status.cgi", "testAccount.cgi", "upload.cgi", "weiterleiten.cgi");
#Files which are stored in the cgi Directory but are no cgi-files
my @notReallyCgiFiles=("fileDownload.pl", "content-types.config", "menu.config");
my @files=("addressbook.html", "addresses.html", "addresses.js", "anzeige.html", "anzeige.js", "avnch4.pdf", "blank.html", "bookmark.html", "bookmark.js", "bottom.html", "chmod.html", "contact.html", "dhtml.js", "download.js", "downloadURL.html", "error.html", "fileListing.js", "filter.html", "filterOverview.html", "helpcredits.html", "helpfunctions.js", "help.html", "icontray.html", "importAddresses.html", "login.html", "logo.html", "mailaccount.html", "mailAddressesTop.html", "mailGeneral.html", "mailMenu.html", "mailPref.html", "mailPref.js", "menu_com.js", "menu.html", "menu.js", "menu_var.js", "modifyBookmark.html", "modify.html", "options.html", "preferences.html", "rule.html", "saveAs.html", "search.html", "sendMail.html", "showMail.html", "showMailProcess.html", "status.html", "upload.html", "winManager.js");
my @images = ("abort.gif", "attachment.gif", "back.gif", "blank.gif", "cancel.gif", 
"checked.gif", "chmodAction.gif", "chn.gif", "copy.gif", "crossDesktop.css", 
"crossDesktopLogin.css", "crossdesktoplogo.gif", "cut.gif", "Deutsch", 
"download.gif", "English", "favicon.ico", "folder.gif", "Francais", 
"fwdedit.gif", "fwd.gif", "header-hg.gif", "logo_small.gif", 
"logout.gif", "mail.gif", "m_down.gif", "menu.css", "m_left16x16.gif", 
"m_left.gif", "modify.gif", "m_right16x16.gif", "m_right.gif", "mw-blank.gif", 
"mw-joinbottom.gif", "mw-join.gif", "mw-line.gif", "mw-minusbottom.gif", 
"mw-minus.gif", "mw-plusbottom.gif", "mw-plus.gif", "new-dir.gif", 
"newDocIcon.gif", "newmail.gif", "newurl.gif", "paste.gif", "prvdir.gif", 
"reloadIcon.gif", "replyall.gif", "reply.gif", "search.gif", "separator.gif", 
"trash.gif", "unchecked.gif", "unzip.gif", "upload.gif", "url-download.gif", 
"url.gif", "view.gif", "viewmail.gif", "zip.gif", "Deutsch/renamefile.gif", "Deutsch/renamefolder.gif", "Deutsch/renameIcon.gif", "Deutsch/width.css", "English/renamefile.gif", "English/renamefolder.gif", "English/renameIcon.gif", "English/width.css", "Francais/renamefile_2.gif", "Francais/renamefile.gif", "Francais/renamefolder.gif", "Francais/width.css");
my @languages=("Deutsch.lng", "English.lng", "Francais.lng");
my @Modules=("Fcntl", "LWP::UserAgent", "Time::Local", "FileHandle", "strict", "Exporter", "Mail::POP3Client", "HTTP::Cookies");

my $scriptUser=getlogin || getpwuid($<) ;
my $base_path="";
my $errorMessage="";
my $zip_checked="";
my $unzip_checked="";

srand;
if ($firstTime eq ""){
	&Error("");
}
#NEU
$base_path=`pwd`;
chomp($base_path);#Last Character: /

$URL=~s/\/setup.cgi//;
$URL=~/^(.*?:\/\/.*?\/)(.*$)/;
my $domain=$1;
my $restURL=$2;
#domain restUrl Sonderzeichen Substitution;
$restURL=~s/(\+|\?|\*|\/|\\|\.|\^|\$|\(|\)|\]|\[|\}|\{)/\\$1/g;
$domain=~s/(\+|\?|\*|\/|\\|\.|\^|\$|\(|\)|\]|\[|\}|\{)/\\$1/g;
$base_path=~s/$restURL$//;
$html_path=$html_URL;
$html_path=~s/$domain/$base_path/;
$html_path=$html_path;
$config_path=$html_path;
$img_path=$img_URL;
$img_path=~s/$domain/$base_path/;
$webdrive_path=$dir_URL;
$webdrive_path=~s/$domain/$base_path/;
if ($install_zip eq "later"){
   $zip_path="Wird sp\&auml;ter installiert";
   $zip_checked="checked";
}
if ($install_unzip eq "later"){
   $unzip_path="Wird sp\&auml;ter installiert";
   $zip_checked="checked";
}
#$errorMessage="Img Path: $img_path. Webdrive Path $webdrive_path. Html Path: $html_path. $restURL. $base_path. $domain.";

if ($secure_path eq "" || $config_path eq "" || $dir_URL eq "" || $img_URL eq "" || $html_URL eq "" ||$redirect eq "" ||$timeout eq "" || $password eq "" || $retype eq ""){
	$errorMessage.="Es wurden nicht alle Eingabefelder ausgef\&uuml;llt.";
}if(!(-e $perl_path)){
	$errorMessage.="Der angegebene Perl-Pfad stimmt nicht.";
}if($install_zip ne "later" && !(-e $zip_path)){
	$errorMessage.="Der angegebene Zip-Pfad stimmt nicht.";
}if($install_unzip ne "later" && !(-e $unzip_path )){
	$errorMessage.="Der angegebene Unzip-Pfad stimmt nicht.";
}if (!($timeout=~/^\d*h*\d*m?\d*s?$/i && $timeout=~/\d+(h|m|s)/i)){
	$errorMessage.="Falsches Timeout-Format";
}if (!($quota=~/^\s*\d+\s*(MB|KB|GB)\s*$/i)){
	$errorMessage.="Invalid quota form: it has to be a natural number followed by KB, MB or GB.";
}if ($password ne $retype){
	$errorMessage.="Zwei verschiedene Pa\&szlig;w\&ouml;rter wurden angegeben.";
}

if ($errorMessage ne ""){
	$errorMessage=~s/\./.<br>/g;
	&Error($errorMessage);
}
$secure_path=~s/\/$//;
$config_path=~s/\/$//;
$webdrive_path=~s/\/$//;
$dir_URL=~s/\/$//;
$redirect=~s/\/$//;
$img_URL=~s/\/$//;
$img_path=~s/\/$//;
$html_URL=~s/\/$//;
$html_path=~s/\/$//;

#transform quota and timeout in one int
my $quotaint=10;
$quota=~/(\d+)\s*(MB|KB|GB)/i;
if ($2 eq "KB"|| $2 eq "kb"||$2 eq "Kb"||$2 eq "kB"){$quotaint=$1;}
elsif ($2 eq "MB"|| $2 eq "mb"||$2 eq "Mb"||$2 eq "mB"){$quotaint=$1*1024;}
elsif ($2 eq "GB"|| $2 eq "gb"||$2 eq "Gb"||$2 eq "gB"){$quotaint=$1*1048576;}

my $timeoutint=0;
if ($timeout=~/(\d+)s/i){$timeoutint=$1;}
if ($timeout=~/(\d+)m/i){$timeoutint+=$1*60;}
if ($timeout=~/(\d+)h/i){$timeoutint+=$1*3600;}


#Create directories, if they do not exist, and check afterwards the existence and read/write permissions
#------------------------------------
if (!(-e $secure_path)){
	makedir($secure_path);
	if (!(-e $secure_path)){
		Error("$secure_path konnte nicht erstellt werden. Pr\&uuml;fen Sie, ob der User $scriptUser die Rechte zum Erstellen des Verzeichnisses hat. <br>Sie k\&ouml;nnen es manuell erstellen und fortfahren.");
	}
}
if (!-r $secure_path){
	Error ("User $scriptUser hat keine Lese-Rechte zum secure path ($secure_path).");
}
if (!-w $secure_path){
	Error ("User $scriptUser hat keine Schreib-Rechte zum secure path ($secure_path).");
}
#------------------------------------
if (!(-e $config_path)){
	makedir($config_path);
	if (!(-e $config_path)){
		Error("$config_path konnte nicht erstellt werden. Pr\&uuml;fen Sie, ob der User $scriptUser die Rechte zum Erstellen des Verzeichnisses hat. <br>Sie k\&ouml;nnen es manuell erstellen und fortfahren.");
	}
}
if (!-r $config_path){
	Error ("User $scriptUser hat keine Lese-Rechte zum configuration path ($config_path).");
}
if (!-w $config_path){
	Error ("User $scriptUser hat keine Schreib-Rechte zum configuration path ($config_path).");
}

#------------------------------------
if (!(-e $webdrive_path)){
	makedir($webdrive_path);
	if (!(-e $webdrive_path)){
		Error("$webdrive_path konnte nicht erstellt werden. Pr\&uuml;fen Sie, ob der User $scriptUser die Rechte zum Erstellen des Verzeichnisses hat. <br>Sie k\&ouml;nnen es manuell erstellen und fortfahren.");
	}
}

#-------------------------------------
if (!(-e $html_path)){
	makedir($html_path);
	if (!(-e $html_path)){
		Error("$html_path konnte nicht erstellt werden. Pr\&uuml;fen Sie, ob der User $scriptUser die Rechte zum Erstellen des Verzeichnisses hat. <br>Sie k\&ouml;nnen es manuell erstellen und fortfahren.");
	}
}
#if (!-r $html_path){
#	Error ("User $scriptUser has no read access to $html_path.");
#}

#--------------------------------------
if (!(-e $img_path)){
	makedir($img_path);
	if (!(-e $img_path)){
		Error("$img_path konnte nicht erstellt werden. Pr\&uuml;fen Sie, ob der User $scriptUser die Rechte zum Erstellen des Verzeichnisses hat. <br>Sie k\&ouml;nnen es manuell erstellen und fortfahren.");
	}
}
#if (!-r $image_path){
#	Error ("User $scriptUser has no read access to $image_path.");
#}




#unzip into $webdrive_path and $img_path
my $missing;
if (&missingCgiFiles ne ""){
	if (!(-e "$webdrive_path/crossDesktop.tar.gz")){
		if (!(-e "crossDesktop.tar.gz")){
			`tar xfz files.tar.gz`;
			if (!(-e "crossDesktop.tar.gz")){
				Error ("Konnte crossDesktop.tar.gz nicht entpacken. Pr\&uuml;fen Sie, ob files.tar.gz vorhanden ist und ob $scriptUser erlaubt ist die Datei zu entpacken. Sie k\&ouml;nnen sie selbst entpacken und fortfahren.");
			}
		}
		`mv crossDesktop.tar.gz $webdrive_path/`;
		if (!(-e "$webdrive_path/crossDesktop.tar.gz")){
			Error("crossDesktop.tar.gz konnte nicht nach $webdrive_path verschoben werden. <br>Pr\&uuml;fen Sie, ob $scriptUser das Recht hat  crossDesktop.tar.gz in das Verzeichnis zu verschieben. <br>Sie k\&ouml;nnen sie selbst verschieben und fortfahren.");
		}
	}
	`tar xfz $webdrive_path/crossDesktop.tar.gz -C $webdrive_path`;
	if (($missing=&missingCgiFiles) ne ""){
		Error("$missing konnte nicht entpackt werden. <br>Pr\&uuml;fen Sie, ob  $scriptUser das Recht hat Dateien in das Verzeichnis $webdrive_path zu entpacken und ob crossDesktop.tar.gz die fehlenden Dateien enth\&auml;lt.<br> Sie k\&ouml;nnen die Dateien selbst entpacken und fortfahren.");
	}
}

if (&missingHtmlFiles ne ""){
	if (!(-e "$html_path/html.tar.gz")){
		if (!(-e "html.tar.gz")){
			`tar xfz files.tar.gz`;
			if (!(-e "html.tar.gz")){
				Error ("Konnte html.tar.gz nicht entpacken. Pr\&uuml;fen Sie, ob files.tar.gz vorhanden ist und ob $scriptUser erlaubt ist die Datei zu entpacken. Sie k\&ouml;nnen sie selbst entpacken und fortfahren.");
			}
		}
		`mv html.tar.gz $html_path/`;
		if (!(-e "$html_path/html.tar.gz")){
			Error("html.tar.gz konnte nicht nach $html_path verschoben werden. <br>Pr\&uuml;fen Sie, ob $scriptUser das Recht hat  html.tar.gz in das Verzeichnis zu verschieben. <br>Sie k\&ouml;nnen sie selbst verschieben und fortfahren.");
		}
	}
	`tar xfz $html_path/html.tar.gz -C $html_path`;
	if (($missing=&missingHtmlFiles) ne ""){
		Error("$missing konnte nicht entpackt werden. <br>Pr\&uuml;fen Sie, ob  $scriptUser das Recht hat Dateien in das Verzeichnis $html_path zu entpacken und ob html.tar.gz die fehlenden Dateien enth\&auml;lt.<br> Sie k\&ouml;nnen die Dateien selbst entpacken und fortfahren.");
	}
}

if (&missingLanguages ne ""){
	if (!(-e "$config_path/languages.tar.gz")){
			if (!(-e "languages.tar.gz")){
				`tar xfz files.tar.gz`;
				if (!(-e "languages.tar.gz")){
					Error ("Konnte languages.tar.gz nicht entpacken. Pr\&uuml;fen Sie, ob files.tar.gz vorhanden ist und ob $scriptUser erlaubt ist die Datei zu entpacken. Sie k\&ouml;nnen sie selbst entpacken und fortfahren.");
				}
			}
			`mv languages.tar.gz $config_path/`;
			if (!(-e "$config_path/languages.tar.gz")){
				Error("languages.tar.gz konnte nicht verschoben werden. <br>Pr\&uuml;fen Sie, ob $scriptUser das Recht hat  languages.tar.gz in das Verzeichnis ($config_path) zu verschieben. <br>Sie k\&ouml;nnen sie selbst verschieben und fortfahren.");
			}
	}
	`tar xfz $config_path/languages.tar.gz -C $config_path`;
	if (($missing=&missingLanguages) ne ""){
		Error("$missing konnte nicht entpackt werden. <br>Pr\&uuml;fen Sie, ob  $scriptUser das Recht hat Dateien in das Verzeichnis $config_path zu entpacken und ob languages.tar.gz die fehlenden Dateien enth\&auml;lt.<br> Sie k\&ouml;nnen die Dateien selbst entpacken und fortfahren.");
	}

}


if (&missingImages ne ""){
	if (!(-e "$img_path/images.tar.gz")){
			if (!(-e "images.tar.gz")){
				`tar xfz files.tar.gz`;
				if (!(-e "images.tar.gz")){
					Error ("Konnte images.tar.gz nicht entpacken. Pr\&uuml;fen Sie, ob files.tar.gz vorhanden ist und ob $scriptUser erlaubt ist die Datei zu entpacken. Sie k\&ouml;nnen sie selbst entpacken und fortfahren.");
				}
			}
			`mv images.tar.gz $img_path/`;
			if (!(-e "$img_path/images.tar.gz")){
				Error("images.tar.gz konnte nicht verschoben werden. <br>Pr\&uuml;fen Sie, ob $scriptUser das Recht hat  images.tar.gz in das Verzeichnis zu verschieben. <br>Sie k\&ouml;nnen sie selbst verschieben und fortfahren.");
			}
	}
	`tar xfz $img_path/images.tar.gz -C $img_path`;
	if (($missing=&missingImages) ne ""){
		Error("$missing konnte nicht entpackt werden. <br>Pr\&uuml;fen Sie, ob  $scriptUser das Recht hat Dateien in das Verzeichnis $img_path zu entpacken und ob images.tar.gz die fehlenden Dateien enth\&auml;lt.<br> Sie k\&ouml;nnen die Dateien selbst entpacken und fortfahren.");
	}

}

#Make content directories
mkdir "$secure_path/files", 0755;
mkdir "$secure_path/files/mail", 0755;


#Create Password File
my @chars = ( "A" .. "Z", "a" .. "z", 0 .. 9);
my $salt = join ("",@chars[ map { rand @chars } (1,2) ]);
open (PASSWORD,">$secure_path/pass") || Error("Konnte nicht \&ouml;ffnen: $secure_path/pass for writing. $!");
print PASSWORD (crypt($password,$salt));
close PASSWORD;

#Change Mode of every cgi file to 755
my $element;
my $cnt;
my $failed="";
foreach $element(@cgifiles){
	$cnt=chmod 0755, "$webdrive_path/$element";
	if ($cnt!=1){
		$failed.="$element, ";
	}
}
$failed=~s/, $//;
my $warning="";
if ($failed ne ""){
 	$warning= "WARNUNG: $failed konnte nicht in den Executable Mode gesetzt werden. <br>F\&uuml;hren Sie es selbst aus (chmod ugo+x file.cgi) andernfalls kann das Script nicht ausgef\&uuml;hrt werden.";
}

#Change first line of every script to #!perl_path
my $file;
my $content;
if ($perl_path ne "/usr/bin/perl"){
	foreach $file(@cgifiles){
		open(FILE, "$webdrive_path/$file") || Error("Konnte nicht \&ouml;ffnen: $webdrive_path/$file");
		$content=join('',<FILE>);
		$content=~s/\#!\/usr\/bin\/perl/\#!$perl_path/;
		close FILE;
		open(FILE, ">$webdrive_path/$file") || Error("Konnte nicht \&ouml;ffnen: $webdrive_path/$file");
		print FILE $content;
		close FILE;
	}
}

#Create index.html for webdrive_path img_path and html_path
if (!(-e "$webdrive_path/index.html")){
	open (INDEX, ">$webdrive_path/index.html")||Error("Konnte nicht erstellen: $webdrive_path/index.html. <br> Pr\&uuml;fen Sie, ob der User $scriptUser das Recht hat Dateien in diesem Verzeichnis zu erstellen. <br> Sie k\&ouml;nnen die Datei selbst erstellen und fortfahren.");
	print INDEX '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="REFRESH" content="0;URL=login.cgi">
<title>Cross-Desktop - Web-Applikations-Suite - Installation</title>
</head>

<body>
</body>
</html>';
close INDEX;
}

if (!(-e "$img_path/index.html")){
	open (INDEX, ">$img_path/index.html")||Error("Konnte nicht erstellen: $img_path/index.html. <br> Pr\&uuml;fen Sie, ob der User $scriptUser das Recht hat Dateien in diesem Verzeichnis zu erstellen. <br> Sie k\&ouml;nnen die Datei selbst erstellen und fortfahren.");
	print INDEX '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="REFRESH" content="0;URL='.$dir_URL.'/login.cgi">
<title>Cross-Desktop - Web-Applikations-Suite - Installation</title>
</head>

<body>
</body>
</html>';
close INDEX;
}

if (!(-e "$html_path/index.html")){
	open (INDEX, ">$html_path/index.html")||Error("Konnte nicht erstellen: $html_path/index.html. <br> Pr\&uuml;fen Sie, ob der User $scriptUser das Recht hat Dateien in diesem Verzeichnis zu erstellen. <br> Sie k\&ouml;nnen die Datei selbst erstellen und fortfahren.");
	print INDEX '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="REFRESH" content="0;URL='.$dir_URL.'/login.cgi">
<title>Cross-Desktop - Web-Applikations-Suite - Installation</title>
</head>

<body>
</body>
</html>';
close INDEX;
}


#Write the Config file
open (CONFIGFILE,">$webdrive_path/crossDesktop.config")|| Error("Konnte nicht zum Schreiben \&ouml;ffnen: $webdrive_path/crossDesktop.config.");
print CONFIGFILE "\# Just enter directorynames without \"/\" at the end
secure_path $secure_path
dir_URL $dir_URL
img_URL $img_URL
html_URL $html_URL
html_path $html_path
zip_path $zip_path
unzip_path $unzip_path
redirect $redirect
session_timeout $timeoutint
files_path $secure_path/files
default_quota $quotaint
showedBase $basename";
close CONFIGFILE;

#Create the htaccess file
if ($username ne ""|| $password_file ne ""){
	if ($password_file eq ""){$password_file="$secure_path/.passfile";}
	open (HTACCESS, ">$secure_path/.htaccess")|| Error ("Konnte nicht zum Schreiben \&ouml;ffnen: $secure_path/.htaccess.");
	print HTACCESS "AuthUserFile $password_file
AuthGroupFile /dev/null
AuthName \"Private Area\"
AuthType Basic
<Limit GET POST>
require valid-user
</Limit>";
	close HTACCESS;

	if (!(-e "$password_file")){
		open (PASS, ">$password_file");
		my $crypted=&Crypt_Password($htaccess_password);
		print PASS "$username:$crypted";
		close PASS;
		
		#`htpasswd -bc $password_file $username $htaccess_password`;
		if (!(-e "$password_file")){Error ("Konnte nicht erstellen: $password_file. <br> Sie k\&ouml;nnen die Datei selbst erstellen (mit htpasswd) und fortfahren.");}
	}
		
}

#delete *.tar.gz
unlink "$webdrive_path/crossDesktop.tar.gz", "$img_path/images.tar.gz", "$html_path/html.tar.gz", "$config_path/languages.tar.gz", "files.tar.gz";

#return HTML Page
my $zip_information="";
if ($install_zip eq "later"|| $install_unzip eq "later"){
  $zip_information="Bevor Sie den Cross-Desktop verwenden, geben Sie bitte den Zip- und Unzip-Pfad in der Datei crossDesktop.config an. Andernfalls stehen Ihnen die Zip-Funktionen nicht zur Verf\&uuml;gung.<br><br>";
}

my $missingModules="";
foreach my $module (@Modules){
	eval("use $module");
	if ($@) {
    		$missingModules.="$module, ";
	}
}
if ($missingModules ne ""){
	$missingModules=~s/, $//;
	$warning.="<br>Einige Module werden vermi\&szlig;t: $missingModules<br> Installieren Sie diese Module, um Cross-Desktop uneingeschr\&auml;nkt verwenden zu k\&ouml;nnen!!<br>";
}


print header();

print <<EOP;
<html><head><title>Die Konfiguration war erfolgreich</title>
<style type="text/css">
<!--	BODY {
	FONT-SIZE: 11px; FONT-FAMILY: verdana, helvetica, sans-serif; BACKGROUND-COLOR: #f9f9f8; margin-right:5px;
  		margin-left:5px;
		margin-top:5px;
  
}
TD {
	FONT-SIZE: 11px; COLOR: #000000; FONT-FAMILY: verdana, helvetica, sans-serif 
}
INPUT {
	FONT-SIZE: 11px; FONT-FAMILY: verdana, helvetica, sans-serif
}
TABLE{
	width: 100%; border:0px;
}
.row2 {
	/*BACKGROUND-COLOR: #FFFFFF*/
	font-weight:bold;
}
.row1 {
	/*BACKGROUND-COLOR: #EEEEEE*/
}
.head1 {
	FONT-WEIGHT: bold; 
	FONT-SIZE: 20px; 
	COLOR:#FFFFFF;
	TEXT-ALIGN: center;
}
.head1Table{
	BACKGROUND-COLOR: #3980f4;
	border-width:1px 1px 1px 1px; 
	border-style:solid; 
	border-color:#00138c;
}
.greyBox{
	border-width:1px; border-style:solid; border-color:#00138c;
	background-color: #EDEBE6
}
.prob {color:#990000;
	font-size:13px;
	font-weight:bold;
}
.haveFun{
	color:#000099;
	font-size:18px;
	font-weight:bold;
}
</style>

</head>

<BODY>
<table cellpadding=3 cellspacing=1>
<tr><td>
<table class="head1Table">
	<tr><td class="head1" > Die Konfiguration war erfolgreich </td></tr>
</table>
</td></tr>
<tr><td>
<table class="greyBox" >
<tr class='col2'><td colspan=3>&nbsp;&nbsp;</td></tr>
<tr><td class='prob' colspan=3 align="center">$warning</td></tr>
<tr class='row2'><td colspan=3>Ihre Einstellungen</td></tr>

<tr class='row1'><td width=2%>&nbsp;</td><td width="25%">Secure path* </td><td> $secure_path</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Cross-Desktop path </td><td> $webdrive_path</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Cross-Desktop URL* </td><td> $dir_URL</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>HTML path* </td><td> $html_path</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>HTML URL* </td><td> $html_URL</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Image path </td><td> $img_path</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Image URL* </td><td> $img_URL</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Perl path </td><td> $perl_path</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Zip path* </td><td> $zip_path</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Unzip  path* </td><td> $unzip_path</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Redirect to* </td><td> $redirect</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Session timeout* </td><td> $timeout (is $timeoutint seconds)</td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Quota* </td><td> $quotaint kb, $quota </td></tr>
<tr class='row1'><td width=2%>&nbsp;</td><td>Basename* </td><td> $basename</td></tr>

<tr><td colspan=3><center>Sie k\&ouml;nnen jeden der mit * markierten Einstellungen in der Datei $webdrive_path/crossDesktop.config \&auml;ndern (Seien Sie vorsichtig. F\&uuml;gen Sie <i>kein</i> "/" an das Ende eines Verzeichnisnamens).<br>
Die weiteren Informationen wurde lediglich f\&uuml;r die Installation verwendet.
<br><br>$zip_information</td></tr>
<tr><td colspan=3 class="prob"><center>Aus Sicherheitsgr\&uuml;nden sollten Sie die Datei setup.cgi entfernen. So vermeiden Sie \&Auml;nderungen Ihrer Konfiguration und der Kennw\&ouml;rter durch Dritte.<br><br></td></tr>
<tr><td colspan=3 ><center>Sie k\&ouml;nnen Cross-Desktop jetzt mit <a href="$html_URL/">$html_URL/</a> (or <a href="$dir_URL/login.cgi">$dir_URL/login.cgi</a> wenn die Datei index.html funktioniert) starten.<br>
<!--Der Anmeldename ist $defaultUser. -->Das Pa\&szlig;wort haben Sie selbst gew\&auml;hlt.<!-- Die Einstellungen zu $defaultUser k\&ouml;nnen im Admin-Dialog des Cross-Desktop jederzeit ge\&auml;ndert werden (default path etc...).--></td></tr>
<tr><td colspan=3>&nbsp;&nbsp;</td></tr>
<tr><td colspan=3 class='haveFun'><center>Wir w\&uuml;nschen viel Spa\&szlig; mit Cross-Desktop.</center></td></tr>
</table>
</td></tr>
</table>
</body>
</html>

EOP



sub Error{
	$error=shift @_;
	$error="<tr><td colspan=4 align=center class='prob'>$error</td></tr>";
	print header();
	
	print <<EOP;
	<html><head><title>Cross-Desktop Konfiguration</title>
	<style type="text/css">
	<!--
	BODY {
	FONT-SIZE: 11px; FONT-FAMILY: verdana, helvetica, sans-serif; BACKGROUND-COLOR: #f9f9f8; margin-right:5px;
  		margin-left:5px;
		margin-top:5px;
  
}
TD {
	FONT-SIZE: 11px; COLOR: #000000; FONT-FAMILY: verdana, helvetica, sans-serif 
}
INPUT {
	FONT-SIZE: 11px; FONT-FAMILY: verdana, helvetica, sans-serif
}
TABLE{
	width: 100%; border:0px;
}
.row2 {
	/*BACKGROUND-COLOR: #FFFFFF*/
	font-weight:bold;
}
.row1 {
	/*BACKGROUND-COLOR: #EEEEEE*/
}
.head1 {
	FONT-WEIGHT: bold; 
	FONT-SIZE: 20px; 
	COLOR:#FFFFFF;
	TEXT-ALIGN: center;
}
.head1Table{
	BACKGROUND-COLOR: #3980f4;
	border-width:1px 1px 1px 1px; 
	border-style:solid; 
	border-color:#00138c;
}
.greyBox{
	border-width:1px; border-style:solid; border-color:#00138c;
	background-color: #EDEBE6
}
.prob {color:#990000;
	font-size:13px;
	font-weight:bold;
}
	//-->
	</style>
	
	</head>
	
	<BODY>
	<form name="Configform" ENCTYPE='multipart/form-data' method='Post' action="setup.cgi">
	<table width='100%' cellpadding=3 cellspacing=1>
	<tr><td>
	<table class="head1Table">
		<tr><td class="head1" > Cross-Desktop Konfiguration </td></tr>
	</table>
	</td></tr>
	<tr><td>
	<table class="greyBox">

	
	$error

	<tr class="row2"><td width=1%>&nbsp;</td><td width=15%>Secure Path</td><td colspan=2><input type=text name="secure_path" value="$secure_path" size=70 ></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	Pfad zur Verwaltung von Passw&ouml;rtern und SessionIDs des Benutzers. Das Verzeichnis wird bei der Installation automatisch erzeugt, wenn es nicht bereits existiert. Der System-User der das setup.cgi ausf&uuml;hrenden Website muss dazu Schreibrechte besitzen. In diesem Verzeichnis wird von Cross-Desktop ein Verzeichnis f&uuml;r Benutzerdaten angelegt. Bei entsprechenden Schreibrechten (ausf&uuml;hrender User des setup.cgi) wird das Verzeichnis automatisch angelegt.<br>Beispiel: 
	<br>Konzept 1: /home/www/website/html/xddata/store
	<br>Konzept 2: /home/xddata/store
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
	
	<tr class="row2"><td>&nbsp;</td><td>URL</td><td colspan=2><input type=text name="dir_URL" value="$dir_URL" size=70></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	URL zu den Programmdateien von Cross-Desktop (Verzeichnis wird erstellt, wenn nicht vorhanden). Es mu\&szlig; m\&ouml;glich sein cgi-Scripte in diesem Verzeichnis auszuf\&uuml;hren. <br>Beispiel: http://www.website.de/cgi-bin/crossDesktop
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
		
	<tr class="row2"><td>&nbsp;</td><td>HTML URL</td><td colspan=2><input type=text name="html_URL" value="$html_URL" size=70></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	URL zu den Html- und Javascript-Dateien von Cross-Desktop (Verzeichnis wird erstellt, wenn nicht vorhanden). <br>Beispiel: http://www.website.de/crossDesktop/html
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
		
	<tr class="row2"><td>&nbsp;</td><td>Image URL</td><td colspan=2><input type=text name="img_URL" value="$img_URL" size=70></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	URL zu den Bilddateien von Cross-Desktop (Verzeichnis wird erstellt, wenn nicht vorhanden). <br>Beispiel: http://www.website.de/crossDesktop/images
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
	
	<tr class="row2"><td>&nbsp;</td><td>Perl path</td><td colspan=2><input type=text name="perl_path" value="$perl_path" size=70></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	Verzeichnis in dem sich die Perl-Installation befindet. Normalerweise /usr/bin/perl. Sie finden die Information in der Dokumentation Ihres ISP.
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>

	<tr class="row2"><td>&nbsp;</td><td>Zip path</td><td colspan=2><input type=text name="zip_path" value="$zip_path" size=70><input type=checkbox $zip_checked name=install_zip value="later">Zip sp\&auml;ter installieren</td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	Verzeichnis in dem sich das Zip-Programm befindet. Normalerweise /usr/bin/zip. Sie finden die Information in der Dokumentation Ihres ISP.
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>

	<tr class="row2"><td>&nbsp;</td><td>Unzip path</td><td colspan=2><input type=text name="unzip_path" value="$unzip_path" size=70><input type=checkbox  $unzip_checked name=install_unzip value="later">Unzip sp\&auml;ter installieren</td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	Verzeichnis in dem sich das Unzip-Program befindet. Normalerweise /usr/bin/unzip. Sie finden die Information in der Dokumentation Ihres ISP.
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>

	
	<tr class="row2"><td>&nbsp;</td><td>Redirect</td><td colspan=2><input type=text name="redirect" value="$redirect" size=70></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	URL zur Umleitung des Benutzers nach Abmelden aus Cross-Desktop. <br>Beispiel: 
	<br>Homepage: http://www.website.de/
	<br>Re-Login: http://www.website.de/crossDesktop/html (HTML-Pfad enth&auml;lt Umleitung)
	<br>Re-Login: http://www.website.de/cgi-bin/crossDesktop/login.cgi (direkter Aufruf)
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
	
	<tr class="row2"><td>&nbsp;</td><td>Session Timeout</td><td colspan=2><input type=text name="timeout" value="$timeout"></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	Periode f\&uuml;r die Laufzeit einer Benutzer-Session. Die Zeit kann in der Form 4h f\&uuml;r vier Stunden oder 3h4m30s f\&uuml;r drei Stunden, vier Minuten und 30 Sekunden angegeben werden. Es m\&uuml;ssen immer ganze Zahlen angegeben werden.
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
	
	<tr class="row2"><td>&nbsp;</td><td>Maximum Quota</td><td colspan=2><input type=text name="quota" value="$quota"></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	Speicherbegrenzung im Datei-Explorer. Angabe in KB, MB oder GB. Bitte nur ganze Zahlen verwenden. Beispiel: 100MB.
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
	
	<tr class="row2"><td>&nbsp;</td><td>Showed basename</td><td colspan=2><input type=text name="basename" value="$basename"></td></tr>
	<tr class="row1"><td colspan=2>&nbsp;</td><td colspan=2>
	Bezeichnung f&uuml;r das Wurzelverzeichnisses im Datei-Explorer von Cross-Desktop. Beispiel: Start
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
	
	<tr class="row2"><td>&nbsp;</td><td>Password</td><td colspan=2><input type=password name="password"></td></tr>
	<tr class="row1"><td>&nbsp;</td><td>Retype password:</td><td colspan=2><input type=password name="retype"></td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>

	<tr class="row2" ><td>&nbsp;</td>
		<td colspan=3>Protection of the secure path (optional)</td></tr>
	<tr class="row1"><td>&nbsp;</td><td>Username:</td><td colspan=2><input type=text name="username" value="$username"></td></tr>
	<tr class="row1"><td>&nbsp;</td><td>Password:</td><td colspan=2><input type=password name="htaccess_password" ></td></tr>
	<tr class="row1"><td>&nbsp;</td><td>&nbsp;</td><td colspan=2>
	Diese Option dient der Erstellung einer .htaccess Datei zum Sch\&uuml;tzen der Benutzerdaten f\&uuml;r den Fall, das die Benutzerdaten im Sichtbereich des Webservers gespeichert werden (siehe Installations-Konzept 1). Diese Option erlaubt einen Benutzer f\&uuml;r den kontrollierten Zugriff auf diesen Dateibereich zu definieren oder eine bereits bestehende Benutzerliste zu verwenden. Achtung: Mit dieser Benutzergruppe sind Administratoren gemeint und nicht alle Benutzer des Cross-Desktop. Fr weiterfhrende Informationen zur Verwendung von .htaccess Dateien verweisen wir auf die Dokumentation ihres Web-Servers.
	</td></tr>
	<tr class="row1"><td>&nbsp;</td><td>Password file:</td><td colspan=2><input type=text name="password_file" value="$password_file" size=70></td></tr>
	<tr class="row1"><td>&nbsp;</td><td>&nbsp;</td><td colspan=2>
	(Optional, f&uuml;r Experten!) Mit dieser Option kann eine bestehende Passwort-Datei verwendet werden. Die Parameter Username und Password sind dann nicht auszuf&uuml;llen.
	</td></tr>
	<tr><td colspan=4>&nbsp;&nbsp;</td></tr>
	</table>
	</td></td>
	<tr><td>
	<table class=greyBox>
		<tr> <td colspan=3>&nbsp;</td></tr>
		<tr align=center><td width=33% align=center ><input type="submit" name="Submit" value="OK" style="width:80px"></td>
		<td width = 33%><input type="reset" name="Clear" value="L\&ouml;schen" style="width:80px"></td>
		<td><input type=button value="Zur\&uuml;cksetzen" onclick="javascript:resetValues()" style="width:80px"></td></tr>
		<tr> <td colspan=3>&nbsp;</td></tr>
	</table>
	</td></tr>
	</table>
	<input type="hidden" name="URL" value="">
	<input type="hidden" name="firstTime" value="No">

	</form>
EOP
	print '
	<SCRIPT LANGUAGE="JavaScript"><!-- Hide script
	var dir=document.URL;
	document.Configform.URL.value=dir;
	//alert(document.Configform.URL.value);
	var url="";
	if (document.Configform.URL.value ==""){
		url=window.prompt("Ihr Browser versendet die aktuelle URL nicht. Bitte geben Sie sie hier ein (Z.B. http://www.mysite.com/crossDesktop/setup.cgi). Andernfalls scheitert die Installation.","http://www.mysite.com/crossDesktop/setup.cgi");
		document.Configform.URL.value=url;
		dir=url;
	}';
if ($firstTime eq ""){
	print 'function resetValues(){
		dir=dir.replace(/\/setup\.cgi/,"");
		document.Configform.dir_URL.value=dir;
		dir=dir.replace(/\/cgi-bin.*/,"");
		document.Configform.img_URL.value=dir+"/crossDesktop/images";
		document.Configform.html_URL.value=dir+"/crossDesktop/html";
		re = /(http:\/\/[^\/]*)/;
		re.exec(dir);
		document.Configform.redirect.value=RegExp.$1;

	}
	resetValues();	';
	}
print '	// End script hiding --></SCRIPT>
</BODY>
	</HTML>';
	exit;
	
}

sub missingCgiFiles{
	my $missing="";
	my $file;
	foreach $file(@cgifiles){
		if (!(-e "$webdrive_path/$file")){
			$missing.="$file, ";	
		}
	}
	foreach $file(@notReallyCgiFiles){
		if (!(-e "$webdrive_path/$file")){
			$missing.="$file, ";	
		}
	}

	$missing=~s/,\s$//;
	return $missing;
}

sub missingHtmlFiles{
	my $missing="";
	my $file;
	foreach $file(@files){
		if (!(-e "$html_path/$file")){
			$missing.="$file, ";	
		}
	}
	$missing=~s/,\s$//;
	return $missing;
}

sub missingLanguages{
	my $missing="";
	my $file;
	foreach $file(@languages){
		if (!(-e "$config_path/$file")){
			$missing.="$file, ";	
		}
	}
	$missing=~s/,\s$//;
	return $missing;
}
	

sub missingImages{
	my $missing="";
	my $file;
	foreach $file(@images){
		if (!(-e "$img_path/$file")){
			$missing.="$file, ";	
		}
	}
	$missing=~s/,\s$//;
	return $missing;
}

sub Crypt_Password {
  my ($pwdplain) = $_[0];
  my $salt = seedchar().seedchar();;
  my $result;     
  $result = crypt($pwdplain,$salt);
  return $result;

  sub seedchar { 
    ('a'..'z','A'..'Z','0'..'9','.','/')[rand(64)];
  }
}

sub makedir{
        my $dir=shift @_;
        $dir=~s/^\///;
        my @Dirparts=split "/", $dir;
        my $growingDir="/";
        foreach $element(@Dirparts){
                $growingDir.=$element."/";
                if (!(-e $growingDir)){
                        mkdir $growingDir, 0755;
                }
        }
}
